function wesnoth.wml_actions.fade_screen(cfg)

	wesnoth.wml_actions.color_adjust {red=-25,green=-25,blue=-25}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-50,green=-50,blue=-50}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-75,green=-75,blue=-75}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-100,green=-100,blue=-100}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-125,green=-125,blue=-125}
	wesnoth.interface.delay(60)
	
	wesnoth.wml_actions.hide_unit {{"filter",{}}}
	
	wesnoth.wml_actions.color_adjust {red=-150,green=-150,blue=-150}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-175,green=-175,blue=-175}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-200,green=-200,blue=-200}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-225,green=-225,blue=-225}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-255,green=-255,blue=-255}
end

function wesnoth.wml_actions.unfade_screen(cfg)

	wesnoth.wml_actions.color_adjust {red=-225,green=-225,blue=-225}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-200,green=-200,blue=-200}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-175,green=-175,blue=-175}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-150,green=-150,blue=-150}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-125,green=-125,blue=-125}
	wesnoth.interface.delay(60)
	
	wesnoth.wml_actions.unhide_unit {{"filter",{}}}
	
	wesnoth.wml_actions.color_adjust {red=-100,green=-100,blue=-100}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-75,green=-75,blue=-75}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-50,green=-50,blue=-50}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=-25,green=-25,blue=-25}
	wesnoth.interface.delay(60)
	wesnoth.wml_actions.color_adjust {red=0,green=0,blue=0}
end

function alpha_print(text, size, alpha)

	local c = helper.round(255 * alpha)

	wesnoth.wml_actions.print({
		text = text,
		size = size,
		red = c, green = c, blue = c,
		duration=1000
	})

	wesnoth.interface.delay(20)

	wesnoth.wml_actions.redraw({})
end

function wesnoth.wml_actions.credits_text(cfg)

	local title = cfg.title
	local text = cfg.body
	local duration = cfg.duration
	--local fade_duration = cfg.fade_duration

	if text == nil then
		text = ""
	end

	if title ~= nil then
		text = "<span size='larger' weight='bold'>" .. title .. "</span>\n\n" .. text;
	end

	if duration == nil then
		duration = 5000
	end

	for alpha = 0.0, 1.0, 0.1 do
		alpha_print(text, 20, alpha)
	end

	wesnoth.interface.delay(duration)

	for alpha = 1.0, 0.0, -0.1 do
		alpha_print(text, 20, alpha)
	end

	wesnoth.wml_actions.print({
		text = text,
		size = 20,
		red = 0, green = 0, blue = 0,
		duration=10
	})

	wesnoth.interface.delay(750)
end